package com.ibiz.core.module2.valuerule.validator.im;

import lombok.extern.slf4j.Slf4j;
import com.ibiz.util.valuerule.DefaultValueRule;
import com.ibiz.util.valuerule.VRCondition;
import com.ibiz.util.valuerule.condition.*;
import com.ibiz.core.module2.valuerule.anno.im.IMKgsbmDefault;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;


/**
 * 值规则注解解析类
 * 实体：IM
 * 属性：Kgsbm
 * 值规则：Default
 * 值规则信息：内容长度必须小于等于[1000]
 */
@Slf4j
@Component("IMKgsbmDefaultValidator")
public class IMKgsbmDefaultValidator implements ConstraintValidator<IMKgsbmDefault, String>,Validator {
    private static final String MESSAGE = "值规则校验失败：【内容长度必须小于等于[1000]】";

    @Override
    public boolean isValid(String value, ConstraintValidatorContext context) {
        boolean isValid = doValidate(value);
        if(!isValid) {
            context.disableDefaultConstraintViolation();
            context.buildConstraintViolationWithTemplate(MESSAGE)
                    .addConstraintViolation();
        }
        return doValidate(value);
    }

    @Override
    public boolean supports(Class<?> aClass) {
        return true;
    }

    @Override
    public void validate(Object o, Errors errors) {
        if( o!=null && supports(o.getClass())){
            if (!doValidate((String) o)){
                errors.reject(MESSAGE);
            }
        }
    }

    public boolean doValidate(String value) {
        DefaultValueRule<String> valueRule = new DefaultValueRule<>("默认值规则",MESSAGE,"Kgsbm",value)
                //字符串长度，重复检查模式，重复值范围，基础值规则，是否递归检查。
                .init(1000,"NONE",null,null,false);
        return valueRule.isValid();
    }
}

